// RemoteMessage.h
// 
// Copyright (c) 2004, Ingo Weinhold (bonefish@cs.tu-berlin.de)
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
// 
// Except as contained in this notice, the name of a copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization of the
// copyright holder.

#ifndef REMOTE_MESSAGE_H
#define REMOTE_MESSAGE_H

#include <RMessageBuild.h>

#include <OS.h>

class BMessage;

namespace RemoteMessage {

	enum {
		RMESSAGE_DATA				= 'RMda',
		RMESSAGE_DELIVERY_FAILED	= 'RMdf',
		RMESSAGE_DELIVERY_TIMED_OUT	= 'RMto',
	};

	extern _IMPEXP_RMESSAGE status_t SetData(
		BMessage* envelope,
		const void* data,
		size_t size,
		BMessage* parameters = NULL);

	extern _IMPEXP_RMESSAGE status_t GetData(
		const BMessage* envelope,
		const void** data,
		size_t* size,
		BMessage* parameters = NULL,
		bool* hasParameters = NULL);

	extern _IMPEXP_RMESSAGE status_t ReleaseData(const void* data, size_t size);
};

using RemoteMessage::RMESSAGE_DATA;
using RemoteMessage::RMESSAGE_DELIVERY_FAILED;
using RemoteMessage::RMESSAGE_DELIVERY_TIMED_OUT;


#endif	// REMOTE_MESSAGE_H
