// DebugSupport.h
// 
// Copyright (c) 2004, Ingo Weinhold (bonefish@cs.tu-berlin.de)
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
// 
// Except as contained in this notice, the name of a copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization of the
// copyright holder.

#ifndef RMESSAGE_DEBUG_SUPPORT_H
#define RMESSAGE_DEBUG_SUPPORT_H

#include <Message.h>
#include <Messenger.h>

// message_what
static inline
char*
message_what(uint32 what, char* buffer)
{
	buffer[0] = what >> 24;
	buffer[1] = what >> 16;
	buffer[2] = what >> 8;
	buffer[3] = what;
	buffer[4] = '\0';
	return buffer;
}

// message_what
static inline
char*
message_what(BMessage* message, char* buffer)
{
	return message_what(message->what, buffer);
}

// messenger_to_string
static inline
char*
messenger_to_string(BMessenger _messenger, char* buffer)
{
	struct HackMessenger {
		port_id		fPort;
		int32		fHandlerToken;
		team_id		fTeam;
		int32		extra0;
		int32		extra1;
		bool		fPreferredTarget;
		bool		extra2;
		bool		extra3;
		bool		extra4;
	} * messenger = (HackMessenger*)&_messenger;
	sprintf(buffer, "BMessenger(%ld, %ld, %d)", messenger->fPort,
		messenger->fHandlerToken, messenger->fPreferredTarget);
	return buffer;
}

#endif	// RMESSAGE_DEBUG_SUPPORT_H
