// Messenger.cpp
// 
// Copyright (c) 2004, Ingo Weinhold (bonefish@cs.tu-berlin.de)
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
// 
// Except as contained in this notice, the name of a copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization of the
// copyright holder.

#include <string.h>

#include "Messenger.h"

// constructor
Messenger::Messenger()
{
	*this = BMessenger();
}

// copy constructor
Messenger::Messenger(const BMessenger& other)
{
	*this = other;
}

// GetHashCode
uint32
Messenger::GetHashCode() const
{
	return fHashCode;
}

// =
Messenger&
Messenger::operator=(const BMessenger& other)
{
	_Clear();
	BMessenger::operator=(other);
	_ComputeHash();
	return *this;
}

// _Clear
void
Messenger::_Clear()
{
	memset(this, 0, sizeof(Messenger));
}

// _ComputeHash
void
Messenger::_ComputeHash()
{
	uint8* data = reinterpret_cast<uint8*>(static_cast<BMessenger*>(this));
	fHashCode = 1;
	for (int i = 0; i < (int)sizeof(BMessenger); i++)
		fHashCode = 13 * fHashCode + data[i];
}

